//! Generated by `codegen_payloads`, do not edit by hand.

use serde::Serialize;

use crate::types::{AllowedUpdate, Update};

impl_payload! {
    @[timeout_secs = timeout]
    /// Use this method to receive incoming updates using long polling ([wiki]). An Array of [`Update`] objects is returned.
    ///
    /// [wiki]: https://en.wikipedia.org/wiki/Push_technology#Long_polling
    /// [`Update`]: crate::types::Update
    #[derive(Debug, PartialEq, Eq, Hash, Default, Clone, Serialize)]
    pub GetUpdates (GetUpdatesSetters) => Vec<Update> {
        optional {
            /// Identifier of the first update to be returned. Must be greater by one than the highest among the identifiers of previously received updates. By default, updates starting with the earliest unconfirmed update are returned. An update is considered confirmed as soon as [`GetUpdates`] is called with an offset higher than its update_id. The negative offset can be specified to retrieve updates starting from -offset update from the end of the updates queue. All previous updates will forgotten.
            ///
            /// [`GetUpdates`]: crate::payloads::GetUpdates
            pub offset: i32,
            /// Limits the number of updates to be retrieved. Values between 1-100 are accepted. Defaults to 100.
            pub limit: u8,
            /// Timeout in seconds for long polling. Defaults to 0, i.e. usual short polling. Should be positive, short polling should be used for testing purposes only.
            pub timeout: u32,
            /// A JSON-serialized list of the update types you want your bot to receive. For example, specify [“message”, “edited_channel_post”, “callback_query”] to only receive updates of these types. See [`Update`] for a complete list of available update types. Specify an empty list to receive all update types except chat_member (default). If not specified, the previous setting will be used.
            ///
            /// Please note that this parameter doesn't affect updates created before the call to the getUpdates, so unwanted updates may be received for a short period of time.
            ///
            /// [`Update`]: crate::types::Update
            pub allowed_updates: Vec<AllowedUpdate> [collect],
        }
    }
}
